﻿Public Class Form1
    Dim WithEvents objCF72Command As CF72Command
    Dim returnCode As Long = 0
    Dim returnMessage As String = ""

    Dim dataLength As Long = 0
    Dim x_zeroscale As Single = 1000
    Dim x_spanscale As Single = 8000
    Dim lower As Single
    Dim upper As Single

    Dim XDataBuffer(0) As Single
    Dim YDataBuffer(0) As Single
    Dim rpmDataBuffer(0) As Single


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' 1) 初期化(CF72Commandが生成されていなかったら生成する)
        createCF72CommandObject()
        ' VisualStudio2005以降ではイベント処理でUIへのアクセスを行った場合、クロススレッド例外が発生するため、サンプルではこのようにしております。
        Control.CheckForIllegalCrossThreadCalls = False



    End Sub

    '-----------------------------------------------
    ' name : createCF72CommandObject
    ' detail : 初期化(CF72Commandが生成されていなかったら生成する)
    '-----------------------------------------------
    Private Sub createCF72CommandObject()
        If objCF72Command Is Nothing Then
            objCF72Command = New CF72Command
            ' デフォルトの　CF-7200の　アドレス　192.168.3.59　変更する場合は、下記1行追加
            objCF72Command.SetHostAddress("172.16.61.64") ' CF-7200のアドレス設定例

        End If
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TCDSet.Click
        '  初期化(CF72Commandが生成されていなかったら生成する)
        createCF72CommandObject()

     
        '  トラッキング計測条件設定
        ' トラッキング(オプション)モードON/OFF=1:ON,0:OFF  約７ｓかかります。
        objCF72Command.SetTrackOptionOnOff(1, returnCode, returnMessage)

        ' スケジュール方法=0:回転スケジュール　1:定時間スケジュール,
        'objCF72Command.SetTrackScheduleType(1, returnCode, returnMessage)
        ' 定時間スケジュールサンプル間隔=0.1s
        'objCF72Command.SetTrackTimeModeIntervalTime(0.1, returnCode, returnMessage)

        ' 回転スケジュール,間隔=50r/min , 取り込み開始回転数、終了回転数
        objCF72Command.SetTrackScheduleType(0, returnCode, returnMessage)
        objCF72Command.SetTrackRpmIntervalValue(50.0, returnCode, returnMessage)
        objCF72Command.SetTrackStartRpmValue(1000.0, returnCode, returnMessage)
        objCF72Command.SetTrackStopRpmValue(8000.0, returnCode, returnMessage)
        x_zeroscale = 1000.0
        x_spanscale = 8000.0

        ' サンプルクロック入力源設定=0:内部（定幅トラッキング）　, 1:外部（定比トラッキング）
        objCF72Command.SetSampleClockFlag(1, returnCode, returnMessage)
        ' 検出方式　カップリング　 外部入力　0:EXT SAMPLE、1:EXT　TRIG　 , 　0:AC ,1:DC              
        objCF72Command.SetExtSampleCouplingFlag(0, 0, returnCode, returnMessage)
        ' 検出方式　電圧レベル　外部入力　0:EXT SAMPLE、1:EXT　TRIG　 , 電圧レベル              
        objCF72Command.SetExtSampleLevelValue(0, 0.5, returnCode, returnMessage)
        ' 検出方式　電圧/TTL　　外部入力　0:EXT SAMPLE、1:EXT　TRIG　 , 0:TTL,1:電圧              
        objCF72Command.SetExtSampleLevelMode(0, 1, returnCode, returnMessage)

        'サンプル点数　2:256,3:512,4:1024,5:2048,6:4096,7:8192,8:16384
        objCF72Command.SetSampleFrameFlag(5)


        ' 最大分析次数　0:6.25,1:12.5,2:25,3:50,4:100,5:200,6:400,7:800
        objCF72Command.SetExtSampleMaxOrder(4, returnCode, returnMessage)

        '周波数レンジ
        '0:100k , 1:80k,    2:64k,   3:50k,   4:40k,    5:32k,   6:25k,   7:20k,   8:16k,
        '9:10k  , 10:8k,   11:6.4k, 12: 5k,   13:4k,   14:3.2k, 15:2.5k, 16:2k,   17:1.6k, 
        '18:1k  , 19:800,  20:640,  21: 500,  22:400,  23:320,  24:250,  25:200,  26:160,
        '27:100 , 28:80,   29:64,   30: 50,   31:40,   32:32,   33:25,   34:20,   35:16
        '36:10  , 37:8, 　 38:6.4,  39: 5,    40:4,    41:3.2,  42:2.5,  43:2.0,  44:1.6
        '45:1
        '        objCF72Command.SetFreqRangeFlag(7)

        
        '１回転あたりのパルス数　1個目パラメータ　使用チャンネル　0:EXTSAMPLE, 1:EXT TRG,
        ' ２個目パラメータ　パルス数  
        objCF72Command.SetExtSamplePulseRevValue(0, 1.0, returnCode, returnMessage)

        '表示の設定　　画面毎の設定を行う
        '１画面め　トラッキング設定　 
        objCF72Command.SetFrameActiveNo(0) '  アクティブにする上画面から　０、１，２、、、
        ' トラックする次数
        objCF72Command.SetOrdAnalysisLineOrd(0, 11.1, returnCode, returnMessage)
        objCF72Command.SetOrdAnalysisLineOrd(1, 12.2, returnCode, returnMessage)
        objCF72Command.SetOrdAnalysisLineOrd(2, 13.3, returnCode, returnMessage)
        objCF72Command.SetOrdAnalysisLineOrd(3, 14.4, returnCode, returnMessage)

        ' BAND幅設定
        objCF72Command.SetOrdAnalysisLineBandWidthFlag(0, 3, returnCode, returnMessage)
        objCF72Command.SetOrdAnalysisLineBandWidthFlag(1, 3, returnCode, returnMessage)
        objCF72Command.SetOrdAnalysisLineBandWidthFlag(2, 3, returnCode, returnMessage)
        objCF72Command.SetOrdAnalysisLineBandWidthFlag(3, 3, returnCode, returnMessage)
        ' BAND幅モード　ON
        objCF72Command.SetOrdAnalysisScanBandOnOff(1, returnCode, returnMessage)
        ' ピーク検出モード　ON
        '        objCF72Command.SetOrdAnalysisScanPeakOnOff(1, returnCode, returnMessage)

        'スムージング　タイプ  0:OFF, 1:TYPE1 , 2:TYPE2 
        objCF72Command.SetTrackDisplaySmoozeType(0, returnCode, returnMessage)
        'スムージング　回数
        objCF72Command.SetTrackDisplaySmoozeNum(3, returnCode, returnMessage)


        'トラッキング　表示をON　　　MaxOrderはOFF
        objCF72Command.SetOrdAnalysisLineOnOff(0, 1, returnCode, returnMessage)
        objCF72Command.SetOrdAnalysisLineOnOff(1, 1, returnCode, returnMessage)
        objCF72Command.SetOrdAnalysisLineOnOff(2, 1, returnCode, returnMessage)
        objCF72Command.SetOrdAnalysisLineOnOff(3, 1, returnCode, returnMessage)
        objCF72Command.SetOrdAnalysisOverallOnOff(1, returnCode, returnMessage)
        objCF72Command.SetOrdAnalysisMaxOrdOnOff(0, returnCode, returnMessage)
        ' ピーク検出モード　ON
        '        objCF72Command.SetOrdAnalysisScanPeakOnOff(1, returnCode, returnMessage)



        '２画面目トラッキング設定　 
        objCF72Command.SetFrameActiveNo(1) '　アクティブにする  上画面から　０、１，２、、、
        ' トラックする次数　
        objCF72Command.SetOrdAnalysisLineOrd(0, 22.1, returnCode, returnMessage)
        objCF72Command.SetOrdAnalysisLineOrd(1, 23.2, returnCode, returnMessage)
        objCF72Command.SetOrdAnalysisLineOrd(2, 24.3, returnCode, returnMessage)
        objCF72Command.SetOrdAnalysisLineOrd(3, 23.4, returnCode, returnMessage)
        ' BAND幅設定  0:3bd, 1:5bd , 2:7bd  , 3:9bd , 4:11 
        objCF72Command.SetOrdAnalysisLineBandWidthFlag(0, 1, returnCode, returnMessage)
        objCF72Command.SetOrdAnalysisLineBandWidthFlag(1, 1, returnCode, returnMessage)
        objCF72Command.SetOrdAnalysisLineBandWidthFlag(2, 1, returnCode, returnMessage)
        objCF72Command.SetOrdAnalysisLineBandWidthFlag(3, 1, returnCode, returnMessage)
        ' BAND幅モード　ON
        objCF72Command.SetOrdAnalysisScanBandOnOff(1, returnCode, returnMessage)
        ' ピーク検出モード　ON
        '        objCF72Command.SetOrdAnalysisScanPeakOnOff(1, returnCode, returnMessage)

        'スムージング　タイプ  0:OFF, 1:TYPE1 , 2:TYPE2 
        objCF72Command.SetTrackDisplaySmoozeType(0, returnCode, returnMessage)
        'スムージング　回数
        objCF72Command.SetTrackDisplaySmoozeType(1, returnCode, returnMessage)


        'トラッキング　表示をON　　　　MaxOrderはOFF
        objCF72Command.SetOrdAnalysisLineOnOff(0, 1, returnCode, returnMessage)
        objCF72Command.SetOrdAnalysisLineOnOff(1, 1, returnCode, returnMessage)
        objCF72Command.SetOrdAnalysisLineOnOff(2, 1, returnCode, returnMessage)
        objCF72Command.SetOrdAnalysisLineOnOff(3, 1, returnCode, returnMessage)
        objCF72Command.SetOrdAnalysisOverallOnOff(1, returnCode, returnMessage)
        objCF72Command.SetOrdAnalysisMaxOrdOnOff(0, returnCode, returnMessage)

        ' スケジュール計測保存データ種=0:PowerSpec　1:FOURIE SPEC
        objCF72Command.SetTrackDatTypeFlag(0, returnCode, returnMessage)
        ' スケジュール計測保存最大ブロック数=0:200,1:400,2:600,3:800,4:1000
        objCF72Command.SetTrackDatTypeFlag(0, returnCode, returnMessage)

        ' トラッキング表示
        Dim nKind = 19       ' 1:Time / 2:Auto/ 3:Cross/4:Imp/5:IFFT/6:Cep/7:Hilb/8:Four / 9:Cross/10:FRF/11:Power/12:Oct/13:COP/14:Lift/15:COH/17:Hist/18:TrackFourier/19:TrackPower
        Dim nChannel = 0   ' 0:CH1/1:CH2
        Dim nAttr = 2       ' 0:Real/1:Imag/2:Mag/Phase
        ' 2画面表示
        objCF72Command.SetFrameDisplayNum(2)
        ' ACT 1
        objCF72Command.SetFrameActiveNo(0) ' 上画面から　０、１，２、、、
        objCF72Command.ConnectCurrent(nKind, nChannel, nAttr)
        ' X軸　0:マニュアル設定,1:AUTOSCALE  
        objCF72Command.SetTrackDisplayAutoScaleOnOff(0, returnCode, returnMessage)
        objCF72Command.SetTrackDisplayRpmLowScale(x_zeroscale, returnCode, returnMessage)
        objCF72Command.SetTrackDisplayRpmUpScale(x_spanscale, returnCode, returnMessage)
        ' ACT 2 
        objCF72Command.SetFrameActiveNo(1) ' 上画面から　０、１，２、、、
        nChannel = 1 ' Ch2
        objCF72Command.ConnectCurrent(nKind, nChannel, nAttr)
        ' X軸　0:マニュアル設定,1:AUTOSCALE  
        objCF72Command.SetTrackDisplayAutoScaleOnOff(0, returnCode, returnMessage)
        objCF72Command.SetTrackDisplayRpmLowScale(x_zeroscale, returnCode, returnMessage)
        objCF72Command.SetTrackDisplayRpmUpScale(x_spanscale, returnCode, returnMessage)
        '  トラッキング解析開始
        ' トラッキング解析モードON/OFF=1:ON
        objCF72Command.SetTrackAnalysisModeOnOff(1, returnCode, returnMessage)

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTrackStart.Click
        'tracking　終了でイベントが発生するように指定。
        objCF72Command.executeCommand("EnableEvent", returnCode, returnMessage, "occurredMeasurementDoneTracking", "1")

        ' 解析開始
        objCF72Command.DoStart(returnCode, returnMessage)
    End Sub

    '-----------------------------------------------
    ' name : 
    ' detail : トラッキングデータを読み込み、表示
    '-----------------------------------------------
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReadData.Click
        Dim g As Graphics
        Dim LineNo As Long

        g = PictureBox1.CreateGraphics()

        If RadioButton6.Checked = True Then
            objCF72Command.SetFrameActiveNo(0) '  下画面から　０、１，２、

            lower = objCF72Command.GetDispYLowScale
            upper = objCF72Command.GetDispYUpScale
            dataLength = objCF72Command.ReceiveDisplayDataTrackingX(XDataBuffer, returnCode, returnMessage)
            If returnCode <> 0 Then
                MsgBox(returnMessage)
            End If                                    'LinNo 0 overall,  1:Line1/2:Line2/3:Line3/4:Line5 / -1 MaxORDER

            If RadioButton1.Checked Then
                LineNo = 1
            ElseIf RadioButton2.Checked = True Then
                LineNo = 2
            ElseIf RadioButton3.Checked = True Then
                LineNo = 3
            ElseIf RadioButton4.Checked = True Then
                LineNo = 4
            Else
                LineNo = 0
            End If
            dataLength = objCF72Command.ReceiveDisplayDataTrackingY(YDataBuffer, LineNo, returnCode, returnMessage)

            If returnCode <> 0 Then
                MsgBox(returnMessage)
            End If

            dataLength = objCF72Command.ReceiveDisplayDataTrackingRpm(rpmDataBuffer, returnCode, returnMessage)
            If returnCode <> 0 Then
                MsgBox(returnMessage)
            End If
            wavedisp(g)
        Else
            objCF72Command.SetFrameActiveNo(1) '  下画面から　０、１，２、      
            lower = objCF72Command.GetDispYLowScale
            upper = objCF72Command.GetDispYUpScale
            dataLength = objCF72Command.ReceiveDisplayDataTrackingX(XDataBuffer, returnCode, returnMessage)
            If returnCode <> 0 Then
                MsgBox(returnMessage)
            End If                                    'LinNo 0 overall,  1:Line1/2:Line2/3:Line3/4:Line5 / -1 MaxORDER

            If RadioButton1.Checked Then
                LineNo = 1
            ElseIf RadioButton2.Checked = True Then
                LineNo = 2
            ElseIf RadioButton3.Checked = True Then
                LineNo = 3
            ElseIf RadioButton4.Checked = True Then
                LineNo = 4
            Else
                LineNo = 0
            End If
            dataLength = objCF72Command.ReceiveDisplayDataTrackingY(YDataBuffer, LineNo, returnCode, returnMessage)

            If returnCode <> 0 Then
                MsgBox(returnMessage)
            End If

            dataLength = objCF72Command.ReceiveDisplayDataTrackingRpm(rpmDataBuffer, returnCode, returnMessage)
            If returnCode <> 0 Then
                MsgBox(returnMessage)
            End If
            wavedisp(g)

        End If

        g.Dispose()

    End Sub
    '-----------------------------------------------
    ' name : 
    ' detail : アクティブ画面のデータを取得する
    '-----------------------------------------------

    Private Sub wavedisp(ByVal g As Graphics)
        Dim n As Long
        Dim curvePoints() As Point
        Dim span As Single
        Dim xzero, xspan As Single
        Dim phight As Single
        Dim pwidth As Single
        xzero = x_zeroscale
        xspan = x_spanscale    '  X軸の表示値読み込み 

        phight = PictureBox1.Size.Height
        pwidth = PictureBox1.Size.Width

        If dataLength = 0 Then Return

        ReDim curvePoints(dataLength - 1)
        'Penオブジェクトの作成(幅1の黄色)
        Dim yellowPen As New Pen(Color.Yellow, 1)
        span = upper - lower
        For n = 0 To dataLength - 1
            curvePoints(n).X = pwidth * ((XDataBuffer(n) - xzero) / (xspan - xzero))
            curvePoints(n).Y = phight - (YDataBuffer(n) - lower) * phight / span
        Next n
        g.Clear(Color.Blue)
        g.DrawLines(yellowPen, curvePoints)
        'リソースを開放する
        yellowPen.Dispose()
    End Sub
    Private Sub objCF72Command_occurredMeasurementDoneTracking(ByVal lBlockNo As Long) Handles objCF72Command.occurredMeasurementDoneTracking
        Dim strTmp As String
        strTmp = "occurredMeasurementDoneTracking"
        strTmp = strTmp + ": " + Str(lBlockNo)
        MsgBox(strTmp)
    End Sub

 
    Private Sub PictureBox1_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PictureBox1.Paint
        Dim g As Graphics

        If dataLength = 0 Then Return

        g = e.Graphics

        wavedisp(g)
    End Sub

    Private Sub Button1_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        createCF72CommandObject()
        '周波数レンジ
        '0:100k , 1:80k,    2:64k,   3:50k,   4:40k,    5:32k,   6:25k,   7:20k,   8:16k,
        '9:10k  , 10:8k,   11:6.4k, 12: 5k,   13:4k,   14:3.2k, 15:2.5k, 16:2k,   17:1.6k, 
        '18:1k  , 19:800,  20:640,  21: 500,  22:400,  23:320,  24:250,  25:200,  26:160,
        '27:100 , 28:80,   29:64,   30: 50,   31:40,   32:32,   33:25,   34:20,   35:16
        '36:10  , 37:8, 　 38:6.4,  39: 5,    40:4,    41:3.2,  42:2.5,  43:2.0,  44:1.6
        '45:1
        objCF72Command.SetFreqRangeFlag(7)

        'サンプル点数　2:256,3:512,4:1024,5:2048,6:4096,7:8192,8:16384
        objCF72Command.SetSampleFrameFlag(5)

        '入力カップリング    0:Ch1, 1:Ch2 ,    0:AC , 1:DC
        'objCF72Command.SetInputCoupleFlag(0, 0)
        'objCF72Command.SetInputCoupleFlag(1, 0)

        '入力 CCLD    0:Ch1, 1:Ch2 ,    0:OFF, 1:ON
        'objCF72Command.SetInputCCLDOnOff(0, 0)
        'objCF72Command.SetInputCCLDOnOff(1, 0)

        '電圧レンジ　 0:Ch1, 1:Ch2    rangeflag  0: 10mVrms , 1:31.6mVrms,  2:0.1Vrms , 3:0.316Vrms 
        '    4:1.0Vrms,   5:3.16Vrms    6:10Vrms   7:31.6Vrms    
        'objCF72Command.SetInputRangeFlag(0, 4) ' Ch1 1.0Vrms
        'objCF72Command.SetInputRangeFlag(1, 4) ' Ch2 1.0Vrms

        '入力フィルタ　 0:Ch1, 1:Ch2    filter  flag
        ' 1:FLAT ,2: A  , 3:C , 4: --- , 5: ---- 6: 10Hz HPF  7: 100Hz HPF  ,8: 1kHzLPF ,9: 10kHzLPF
        'objCF72Command.SetInputFilterFlag(0, 1)
        'objCF72Command.SetInputFilterFlag(1, 1)
        '
        '単位　校正値設定  0:Ch1 , 1:Ch2,   設定値　　　V/EU
        objCF72Command.SetEUYUnitVEUValue(0, 0.001234)
        objCF72Command.SetEUYUnitVEUValue(1, 0.002345)
        '単位　校正値　単位名設定  0:Ch1 , 1:Ch2,   設定値　　　
        objCF72Command.SetEUYUnitName(0, "m/s2")
        objCF72Command.SetEUYUnitName(1, "m/s2")

        '単位校正機能　0:Ch1 , 1:Ch2　0：Off,1：On　
        objCF72Command.SetEUYUnitOnOff(0, 1)
        objCF72Command.SetEUYUnitOnOff(1, 1)




        'トリガソース　0:内部、1:外部
        'objCF72Command.SetTrigSourceFlag(0)
        'トリガソース内部 Ch     0:Ch1, 1:Ch2
        'objCF72Command.SetTrigChannelValue(0)
        'トリガレベル   電圧レンジの％　-99～99%
        'objCF72Command.SetTrigLevelValue(10)
        'トリガポジション　　±8192
        'objCF72Command.SetTrigPositionValue(-32)
        'トリガ　モード　     0: repeat , 1: single , 2:OneShot 
        'objCF72Command.SetTrigModeFlag(0)
        'トリガ　On/Off   0:Off,  1:On
        'objCF72Command.SetTrigOnOff(0)



    End Sub
End Class

